# ok.tcl v1.3 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# das tcl liest die onlinekosten.de  news aus und gibt  sie wieder,  gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
# news von hand auslesen.
# leider hat sich onlinekosten.de von einer guten newspage zum thema flatrate
# zu einem peinlichen klatschmagazin gewandelt, so dass ich mich manchmal frage
# ob sie nicht doch axel springer gehren. aber vielleicht interessieren die news
# rund um den net-sheriff noch wen, manche der authoren sollten ihren wortschatz
# noch einmal grndlich berarbeiten um weitere peinlichkeiten zu vermeiden.
#
# v1.3 - komplett umgebaut by public request
#      - link wird gleich mitgepostet
#      - yeah  endlich  keine  windrop  user  mehr die mich fragen was lynx ist
#        so gerne ich support leiste - jeden tag ne  mail mit der  selben frage
#        stresst ziemlich ;)
#
# oktrigger - der trigger auf den der bot reagiert (public und message)
# oklimit - maximum der news die auf befehl geposted werden
# oknewspost  - 1 fr newsposting, 0 fr keines
# okchans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# oknewspostlimit - maximum der news die geposted werden
# isokhub  - legt fest ob der bot newshub ist oder nicht
# okleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set oktrigger ".onlinekosten"
set okchans ""
set oklimit "10"
set oknewspostlimit "3"
set oknewspost "1"
set isokhub "0"
set okleafs ""

####### ende der config #############

bind msg - $oktrigger msg_ok
bind pub - $oktrigger pub_ok
bind time - "?0 * * * *" okcheck

proc sendoknews { arg } {
global okleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $okleafs] [string tolower $bot]] != -1)} {
putbot $bot "onlinekosten: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc html { text } {
regsub -all "&uuml;" $text "" text
regsub -all "&ouml;" $text "" text
regsub -all "&auml;" $text "" text
regsub -all "&Uuml;" $text "" text
regsub -all "&Ouml;" $text "" text
regsub -all "&Auml;" $text "" text
regsub -all "&szlig;" $text "" text
regsub -all "&quot;" $text "\"" text
return $text
}

proc okcheck {nick uhost hand chan arg} {
global okchans oknewspost isokhub oknewspostlimit
set counter 0
if {$oknewspost == 1 } {
putlog "onlinekosten: suche nach neuer newsline"
set oklastnews "none"
if {[file exists ok.hdl]} {
set temp [open "ok.hdl" r]
set oklastnews "[gets $temp]"
close $temp
}
set temp [open "ok.hdl" w+]
if {[catch {set sock [socket www.onlinekosten.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /news/news.php3  HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.onlinekosten.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "\"97%\" class=\"subtxtkasten\">" $bl] != -1 } {
set link www.onlinekosten.de/news/[string range $bl [shrink + 6 "href=\"" 0 $bl] [shrink - 3 "class=\"topthema\"" 0 $bl]]
set newsline [string range $bl [shrink + 17 "class=\"topthema\"" 0 $bl] [shrink - 1 "</a>" 0 $bl]]
puts $temp "[html $newsline] <$link>"
}}}
close $sock ; close $temp
set counter 0
if {$oklastnews == "none" } { putlog "onlinekosten: headlinefile created" ; return 0 }
set temp [open "ok.hdl" r]
while { [eof $temp] != 1 } {
set okneunews [gets $temp]
if {($oklastnews == $okneunews) || ($counter == $oknewspostlimit)} { close $temp;return 0 }
if { $isokhub == "1" } { sendoknews $okneunews }
foreach chan [channels] {
if {$okchans == "" } { putserv "privmsg $chan :(neue onlinekosten newsline) $okneunews" }
if {$okchans != "" } {
if {([lsearch -exact [string tolower $okchans] [string tolower $chan]] != -1) || ($okchans == "")} {putserv "privmsg $chan :(neue onlinekosten newsline) $okneunews"}
}

}
incr counter
 }}}


proc oknews {target limit} {
if {[catch {set sock [socket www.onlinekosten.de 80] } sockerror]} {
puts "error: $sockerror"
return 0 } else {
puts $sock "GET /news/news.php3  HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.onlinekosten.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "\"97%\" class=\"subtxtkasten\">" $bl] != -1 } {
set link www.onlinekosten.de/news/[string range $bl [shrink + 6 "href=\"" 0 $bl] [shrink - 3 "class=\"topthema\"" 0 $bl]]
set newsline [string range $bl [shrink + 17 "class=\"topthema\"" 0 $bl] [shrink - 1 "</a>" 0 $bl]]
putserv "privmsg $target :[incr counter] [html $newsline] <$link>"
}
if {$counter == $limit} {close $sock ; return 0 }
}}}

proc msg_ok { nick uhost hand arg } { global oklimit ; oknews $nick $oklimit }
proc pub_ok { nick uhost hand chan arg } { global okchans oklimit ; if {([lsearch -exact [string tolower $okchans] [string tolower $chan]] != -1) || ($okchans == "")} { oknews $nick $oklimit }}

putlog "*** ok.tcl v1.3 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]